namespace app
{
    public delegate void MyEventHandler();

    public class Poll
    {
        public void startPolling()
        {
            //poll for notifications
        }
        public void stopPolling()
        {
            //stop polling for notifications
        }
    }

    public class User
    {
        //create the UserLogout event
        public event MyEventHandler OnUserLogout;
        public void Logout()
        {
            OnUserLogout();
        }
    }

    public class NavBar
    {
        Poll poll = new Poll();
        User currentUser = new User();

        //When the user logs out, we want something to happen
        void HandleUserLogout()
        {
            //tell polling object to stop
            poll.stopPolling();
        }

        public NavBar()
        {
            poll.startPolling();
            //create a delegate to handle a user logging out
            //and add it to OnUserLogout's event handlers
            currentUser.OnUserLogout += new MyEventHandler(HandleUserLogout);
        }

        private void logout_btn_Click(object sender, EventArgs e)
        {
            currentUser.Logout();
        }
    }
}