(function() {

    angular.module('app')
        .service('SpotifyService', ['$http', function($http) {

            var apiUrl = "https://api.spotify.com/v1/";

            this.getSpotifyArtistIdByName = function(name) {
                return $http.get(apiUrl + "search?q=" + name + "&type=artist")
                    .then(function(response) {
                        return response.data.artists.items[0].id;
                    });
            };

            this.getTopTrackURLForArtist = function(spotifyArtistId) {
                var url = apiUrl + "artists/" + spotifyArtistId + "/top-tracks?country=US";
                return $http.get(url)
                    .then(function(response) {
                        return response.data.tracks[0].preview_url;
                    });
            };

        }]);

})();
