angular
    .module('app')
    .controller('BeerController', ['beerService', 'logger']);

function BeerController(beerService, logger) {
    var vm = this;
    vm.beer = '';
    vm.title = 'Controller Using a Service';
   
    activate();
    
    function activate() {
        return getBeer().then(function() {
            logger.info('Activated Beer Controller');
        });
    }

    function getBeer() {
        return beerService.getBeer().then(function(data) {
            vm.beer = data;
            logger.info(vm.beer + ' returned from service');
            return vm.beer;
        });
    }
}